#include "LCD_I2C.h"

LCD_I2C lcd(0x27,16,2);

int rightBttnPin = 10;
int centerBttnPin = 11;
int leftBttnPin = 12;
int piezoPin = 13;
int turn = 1;
int count = 0;
bool flag = true;
bool flag2 = true;
bool flag3 = true;
int score1 = 0;
int score2 = 0;

const int green_col[4] = {2,3,4,5};
const int red_col[4] = {A3,A2,A1,A0};
const int row[4] = {6,7,8,9};

int red[16] ={

  0,0,0,0,
  0,0,0,0,
  0,0,0,0,
  0,0,0,0,

};

int green[16] ={

  0,0,0,0,
  0,0,0,0,
  0,0,0,0,
  0,0,0,0,

};

int x;

void fourConnect(int* arr, int player){
  if((arr[0] == 1 && arr[1] == 1 && arr[2] == 1 && arr[3] == 1) ||
     (arr[4] == 1 && arr[5] == 1 && arr[6] == 1 && arr[7] == 1) ||
     (arr[8] == 1 && arr[9] == 1 && arr[10] == 1 && arr[11] == 1) ||
     (arr[12] == 1 && arr[13] == 1 && arr[14] == 1 && arr[15] == 1) ||
     
     (arr[0] == 1 && arr[4] == 1 && arr[8] == 1 && arr[12] == 1) ||
     (arr[1] == 1 && arr[5] == 1 && arr[9] == 1 && arr[13] == 1) ||
     (arr[2] == 1 && arr[6] == 1 && arr[10] == 1 && arr[14] == 1) ||
     (arr[3] == 1 && arr[7] == 1 && arr[11] == 1 && arr[15] == 1) ||
     
     (arr[0] == 1 && arr[5] == 1 && arr[10] == 1 && arr[15] == 1) ||
     (arr[3] == 1 && arr[6] == 1 && arr[9] == 1 && arr[12] == 1)){
        if(player == 1){
          score1++;
          lcd.clear();
          lcd.setCursor(2,0);
          lcd.print("Player 1 won");
          lcd.setCursor(3,1);
          lcd.print("Play again");
          turn = 3;
        } else {
          score2++;
          lcd.clear();
          lcd.setCursor(2,0);
          lcd.print("Player 2 won");
          lcd.setCursor(3,1);
          lcd.print("Play again");
          turn = 3;
        }
     }
}

// select row function
void selectRow(int nr){
  for(int i = 0; i < 4; i++){
    if(i == nr){
      digitalWrite(row[i], LOW);
    } else {
      digitalWrite(row[i], HIGH);
    }
  }
}

// select column for red LEDs
void selectRedCol(int nr, int state){
  for(int i = 0; i < 4; i++){
    if(nr == i){
      digitalWrite(red_col[i], state);
    }
  }
}

// select column for green LEDs
void selectGreenCol(int nr, int state){
  for(int i = 0; i < 4; i++){
    if(nr == i){
      digitalWrite(green_col[i], state);
    }
  }
}

void setup() {
  
  lcd.begin();
  lcd.backlight();
  lcd.setCursor(1,0);
  lcd.print("Welcome to C4!");
  lcd.setCursor(2,1);
  lcd.print("Let's start!");
  
  pinMode(rightBttnPin, INPUT_PULLUP);
  pinMode(centerBttnPin, INPUT_PULLUP);
  pinMode(leftBttnPin, INPUT_PULLUP);
  pinMode(piezoPin, OUTPUT);

  for(int i = 0; i < 4; i++){
    pinMode(red_col[i], OUTPUT);
    digitalWrite(red_col[i], LOW);
    pinMode(green_col[i], OUTPUT);
    digitalWrite(green_col[i], LOW);
    pinMode(row[i], OUTPUT);
    digitalWrite(row[i], HIGH);
  }
}
  
void loop() {
  
  int confirmButtonState = digitalRead(centerBttnPin);
  int rightButtonState = digitalRead(rightBttnPin);
  int downButtonState = digitalRead(leftBttnPin);


  // middle button - red
  // player 1 turn
  if(confirmButtonState == HIGH && turn == 1 && flag == true){

    digitalWrite(piezoPin,HIGH);
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Player 1's turn!");
    lcd.setCursor(5,1);
    lcd.print(score1);
    lcd.print(" -- ");
    lcd.print(score2);
    tone(piezoPin, 10000, 500);
    turn = 2;
    flag = false;
    count++;

    x = 0;
    while(red[x] == 1 | green[x] == 1){
      x++;
      if(x > 15){
        x = 0;
      }
    }

    green[x] = 1;

    fourConnect(red,turn);

    
  // player 2 turn
  } else if(confirmButtonState == HIGH && turn == 2 && flag == true){
    
    digitalWrite(piezoPin,HIGH);
    lcd.setCursor(0,0);
    lcd.print("Player 2's turn!");
    lcd.setCursor(5,1);
    lcd.print(score1);
    lcd.print(" -- ");
    lcd.print(score2);
    tone(piezoPin, 1000, 500);
    turn = 1;
    flag = false;
    count++;

    if(count != 16){
      x = 0;
      while(red[x] == 1 | green[x] == 1){
        x++;
        if(x > 15){
          x = 0;
        }
      }
       red[x] = 1;
    } else {
      turn = 3;
      flag = true;
      delay(500);
    }

    fourConnect(green,turn);
  
  // game end
  } else if(confirmButtonState == HIGH && turn == 3 && flag == true){
      lcd.clear();
      lcd.setCursor(3,0);
      lcd.print("Game over!");
      lcd.setCursor(3,1);
      lcd.print("Try again!");
      count = 0;
      turn = 1;
      flag2 = true;
      flag3 = true;
      
      for(int i = 0; i < 16; i++){
        red[i] = 0;
        green[i] = 0;
      }
      
  } else if (confirmButtonState == LOW && flag == false){
    
    flag = true;
    
  }

  // -------------------------------------------------------------------------------
  
  // right button - white
  if(rightButtonState == HIGH && flag2 == true){
    if(turn == 1){
      red[x] = 0;
      x++;
      if(x > 15){
          x = 0;
        }
      while(red[x] == 1 | green[x] == 1){
        x++;
        if(x > 15){
          x = 0;
        }
      }
      red[x] = 1;
      flag2 = false;
      delay(500);
    } else if(turn == 2){
      green[x] = 0;
      x++;
      if(x > 15){
          x = 0;
        }
      while(red[x] == 1 | green[x] == 1){
        x++;
        if(x > 15){
          x = 0;
        }
      }
      green[x] = 1;
      flag2 = false;
      delay(500);
    }
  } else if(rightButtonState == LOW  && flag2 == false){
    
     flag2 = true;
     
  }

  // -------------------------------------------------------------------------------
  
  // left button - white
  if(downButtonState == HIGH && flag3 == true){
    if(turn == 1){
      red[x] = 0;
      x += 4;
      if(x > 15){
          x = (x % 4 + 1) % 4;
        }
      while(red[x] == 1 | green[x] == 1){
        x += 4;
        if(x > 15){
          x = (x % 4 + 1) % 4;
        }
      }
      red[x] = 1;
      flag3 = false;
      delay(500);
    } else if(turn == 2){
      green[x] = 0;
      x += 4;
      if(x > 15){
          x = (x % 4 + 1) % 4;
        }
      while(red[x] == 1 | green[x] == 1){
        x += 4;
        if(x > 15){
          x = (x % 4 + 1) % 4;
        }
      }
      green[x] = 1;
      flag3 = false;
      delay(500);
    }
  } else if(downButtonState == LOW  && flag3 == false){
    
     flag3 = true;
     
  }

  // -------------------------------------------------------------------------------
  
  // LEDs
  for(int i = 0; i < 4; i++){
    selectRow(i);
    for(int j = 0; j < 4; j++){
      selectGreenCol(j, green[i * 4 + j]);
      selectRedCol(j, red[i * 4 + j]);
    }
    delay(2);
    for(int j = 0; j < 4; j++){
      selectGreenCol(j, 0);
      selectRedCol(j, 0);
    }
  }
}
